var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import * as V4 from './version-4';
import { State } from './models';
export class ReportGenerator {
}
function resultV4() {
    return __awaiter(this, void 0, void 0, function* () {
        let project = yield getProject();
        // createDefaultLabels(project);
        // createIssues(project);
        editIssue(project, '5');
    });
}
function getProject() {
    return __awaiter(this, void 0, void 0, function* () {
        const projects = yield V4.Projects.getAll();
        return projects[0];
    });
}
function createDefaultLabels(project) {
    return __awaiter(this, void 0, void 0, function* () {
        let neededLabels = [{ name: 'Epic', color: '#FF0000' },
            { name: 'UserStory', color: '#00FF00' },
            { name: 'task', color: '#00FF00' }];
        console.log('v4');
        const availables = yield V4.Labels.getAll(project.id);
        const missingLables = neededLabels.filter(label => availables.find(item => item.name === label.name) === undefined);
        console.log('Missing Labels', missingLables);
        yield missingLables.map((newLabel) => __awaiter(this, void 0, void 0, function* () {
            let label = yield V4.Labels.create(project.id, newLabel.name, newLabel.color);
            console.log('Label', label);
        }));
    });
}
function createIssues(project) {
    return __awaiter(this, void 0, void 0, function* () {
        let newIssue = yield V4.Issues.create(project.id, 'New UserStory', 'A new Story', undefined, undefined, undefined, ['UserStory'], undefined);
        console.log('New Epic', newIssue);
        let issues = yield V4.Issues.getAllOfProject(project.id, State.OPENED);
        console.log('All Project Issues', issues);
    });
}
function editIssue(project, issueID) {
    return __awaiter(this, void 0, void 0, function* () {
        let editIssue = yield V4.Issues.edit(project.id, issueID, undefined, '@sibling(#6)');
        console.log('editedIssue', editIssue);
    });
}
resultV4();
//# sourceMappingURL=test.js.map