import { service } from './service';
import { REST } from '../common';
const urlencode = require('urlencode');
export var Labels;
(function (Labels) {
    function getAll(projectId) {
        return new Promise((resolve, reject) => {
            service.get(`/projects/${projectId}/labels`)
                .then((result) => resolve(result.body))
                .catch((error) => reject(error));
        });
    }
    Labels.getAll = getAll;
    function create(projectId, name, color, description) {
        let params = [];
        params.push(REST.QueryParam.createQuery('name', name));
        params.push(REST.QueryParam.createQuery('color', urlencode(color)));
        params.push(REST.QueryParam.createQuery('description', description));
        return new Promise((resolve, reject) => {
            service.post(`/projects/${projectId}/labels?${REST.QueryParam.join(params)}`)
                .then((result) => resolve(result.body))
                .catch((error) => reject(error));
        });
    }
    Labels.create = create;
})(Labels || (Labels = {}));
//# sourceMappingURL=labels.js.map