import { service } from './service';
import { Visibility, SortOrder, Orderby } from '../models';
import { REST } from '../common';
export var Projects;
(function (Projects) {
    function getAll(visibity = Visibility.PRIVATE, owned = true, membership = true, sort = SortOrder.ASCENDING, orderby = Orderby.CREATED_AT, search) {
        let params = [];
        params.push(REST.QueryParam.createQuery('visibility', visibity));
        params.push(REST.QueryParam.createQuery('owned', owned.toString()));
        params.push(REST.QueryParam.createQuery('membership', membership.toString()));
        params.push(REST.QueryParam.createQuery('sort', sort));
        params.push(REST.QueryParam.createQuery('order_by', orderby));
        params.push(REST.QueryParam.createQuery('search', search));
        return new Promise((resolve, reject) => {
            service.get(`/projects?${REST.QueryParam.join(params)}`)
                .then((result) => resolve(result.body))
                .catch((error) => reject(error));
        });
    }
    Projects.getAll = getAll;
    function getOne(id) {
        return new Promise((resolve, reject) => {
            service.get(`/projects/${id}`)
                .then((result) => resolve(result.body))
                .catch((error) => reject(error));
        });
    }
    Projects.getOne = getOne;
})(Projects || (Projects = {}));
//# sourceMappingURL=projects.js.map